XREFS(1)

NAME
xrefs - Find crossed assembly references

SYNOPSIS
xrefs [-vqVhe] [-a arch] [-f from] [-t to] [-r range] [-s size] [-d offset] [-X offset] [file] [offset]

DESCRIPTION
This program is part of the radare project.

Find crossed references to a certain offset on x86, arm and powerpc binaries. It supports options for swaping endiannes.

This program can't autodetect xrefs done by registers or data pointers. Only relative ones in jumps or calls.

Xrefs autodetects the binary architecture parsing the ELF or PE headers found in the target file.

-v  Verbose mode. Useful for debugging.

-q  Quite mode. Useful for scripting. Shows the resulting offset number.

-V  Show version information and exits.

-e  Use big endian instead of little endian when searching the related offsets. It's automatically defined by the '-a' flag when choosing the target architecture.

-a arch
    Selects the architecture to be used. Available options: 'x86', 'arm' and 'ppc'.

-f from
    Start looking for related offsets at a certain seek inside the file.

-t to
    Finish xrefs search at a certain offset of the target file.

-r range
    Cut range of valid xrefs. This flag can be used instead of the '-f' and '-t' flags.

-s size
    Define the size of the offset variable. (4 bytes for x86 and 3 for arm and powerpc). This value is automatically defined by the '-a' flag.

-d offset
    Sets a negative delta offset as padding. This is normally the size of the jump/call opcode.

-X offset
    Print out debugging information at a certain offset. This flag is for debugging purposes only. See '-v'

-h  Show usage help message.

HACKING
This program has been written with poor extensibility in mind. So it can probably be buggy on other architectures using them from the commandline. Feel free to send your parches, tips and ideas.

This program has been tested on firmwares, bootloaders, ELF and PE binaries on x86, ppc and arm architectures.

You can use the '-X' and '-v' flags for debugging the xrefs search engine.

SEE ALSO

radiff(1), hasher(1), radare(1), radarerc(5), rfile(1), rabin(1), rsc(1), rasc(1), rasm(1), xc(1)

AUTHORS

pancake <pancake@youterm.com>